# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ResourceHealth::Mgmt::V2018_08_01_preview
  module Models
    #
    # Azure region impacted by the service health event.
    #
    class ImpactedServiceRegion

      include MsRestAzure

      # @return [String] Impacted region name.
      attr_accessor :impacted_region

      # @return [EventStatusValues] Current status of event in the region.
      # Possible values include: 'Active', 'Resolved'
      attr_accessor :status

      # @return [Array<String>] List subscription impacted by the service
      # health event.
      attr_accessor :impacted_subscriptions

      # @return [DateTime] It provides the Timestamp for when the last update
      # for the service health event.
      attr_accessor :last_update_time

      # @return [Array<Update>] List of updates for given service health event.
      attr_accessor :updates


      #
      # Mapper for ImpactedServiceRegion class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'impactedServiceRegion',
          type: {
            name: 'Composite',
            class_name: 'ImpactedServiceRegion',
            model_properties: {
              impacted_region: {
                client_side_validation: true,
                required: false,
                serialized_name: 'impactedRegion',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                serialized_name: 'status',
                type: {
                  name: 'String'
                }
              },
              impacted_subscriptions: {
                client_side_validation: true,
                required: false,
                serialized_name: 'impactedSubscriptions',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              last_update_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastUpdateTime',
                type: {
                  name: 'DateTime'
                }
              },
              updates: {
                client_side_validation: true,
                required: false,
                serialized_name: 'updates',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'UpdateElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'Update'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
